<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit( 'restricted access' );
}

/*
 * This is a function that run when customer add/update/register.
 * $user_id variable return user id.
 */
if ( ! function_exists( 'wc_facturozor_customer_action' ) ) {
  add_action( 'user_register', 'wc_facturozor_customer_action', 10, 1 );
  add_action( 'edit_user_profile_update', 'wc_facturozor_customer_action', 10, 1 );
  add_action( 'woocommerce_update_customer', 'wc_facturozor_customer_action', 10, 1 );
  add_action( 'woocommerce_customer_save_address', 'wc_facturozor_customer_action', 10, 1 );
  add_action( 'woocommerce_save_account_details', 'wc_facturozor_customer_action', 10, 1 );
  function wc_facturozor_customer_action( $user_id ) {
      
    $wc_data = get_option( 'wc_facturozor_module_customers' );
    $wc_facturozor_active = get_site_option( 'wc_facturozor_active' );
    $wc_facturozor_active = (isset($wc_facturozor_active)) ? intval($wc_facturozor_active) : 0;
    if ( ! is_array( $wc_data ) ) {
        $wc_data = array();
    }

    if ( $wc_facturozor_active == 1 ) {
      $facturozor = new WC_FACTUROZOR_MAIN();
      wc_facturozor_customer_synch( $facturozor,$user_id, $wc_data );
    }
  }
}

/*
 * This is a function that run when order add/update.
 * $order_id variable return order id.
 */
if ( ! function_exists( 'wc_facturozor_order_action' ) ) {
  add_action( 'woocommerce_new_order', 'wc_facturozor_order_action', 90, 1 );
  add_action( 'woocommerce_update_order', 'wc_facturozor_order_action', 90, 1 );
  function wc_facturozor_order_action( $order_id ) {
      
    $wc_data = get_option( 'wc_facturozor_module_orders' );
    $wc_facturozor_active = get_site_option( 'wc_facturozor_active' );
    $wc_facturozor_active = (isset($wc_facturozor_active)) ? intval($wc_facturozor_active) : 0;
    if ( ! is_array( $wc_data ) ) {
        $wc_data = array();
    }
    
    if ( $wc_facturozor_active == 1 ) {
        $facturozor = new WC_FACTUROZOR_MAIN();
        wc_facturozor_order_synch( $facturozor, $order_id, $wc_data );
    }
  }
}
/*
 * This is a function that run when product add/update.
 * $product_id variable return product id.
 */
if ( ! function_exists( 'wc_facturozor_product_action' ) ) {
  add_action( 'woocommerce_new_product', 'wc_facturozor_product_action', 90, 1 );
  add_action( 'woocommerce_update_product', 'wc_facturozor_product_action', 90, 1 );
  function wc_facturozor_product_action( $product_id ) {
    $wc_data = get_option( 'wc_facturozor_module_products' );
    $wc_facturozor_active = get_site_option( 'wc_facturozor_active' );
    $wc_facturozor_active = (isset($wc_facturozor_active)) ? intval($wc_facturozor_active) : 0;
    if ( ! is_array( $wc_data ) ) {
        $wc_data = array();
    }
    if ( $wc_facturozor_active == 1 ) {
      $facturozor = new WC_FACTUROZOR_MAIN();
      wc_facturozor_product_synch( $facturozor, $product_id, $wc_data );
    }
  }
}

//payent complete action 
if ( ! function_exists( 'wc_facturozor_payment_complete_action' ) ) {
  add_action( 'woocommerce_order_status_completed', 'wc_facturozor_payment_complete_action', 10, 1  );
  add_action( 'woocommerce_payment_complete', 'wc_facturozor_payment_complete_action', 10, 1  );
  add_action( 'woocommerce_payment_complete_order_status_completed', 'wc_facturozor_payment_complete_action', 10, 1  );
  function wc_facturozor_payment_complete_action($order_id){
    $wc_facturozor_active = get_site_option( 'wc_facturozor_active' );
    $wc_facturozor_active = (isset($wc_facturozor_active)) ? intval($wc_facturozor_active) : 0;
    if ( $wc_facturozor_active == 1 ) {
      $facturozor = new WC_FACTUROZOR_MAIN();
      wc_facturozor_payment_synch($facturozor,$order_id);
    }    
  }
}
/*
 * customer synch.
 * $user_id variable return user id.
 * $wc_fields = array(
                    'first_name'            => 'First Name',
                    'last_name'             => 'Last Name',
                    'user_email'            => 'Email',
                    'billing_company'       => 'Billing Company',
                    'billing_address_1'     => 'Billing Address 1',
                    'billing_city'          => 'Billing City',
                    'billing_state'         => 'Billing State',
                    'billing_postcode'      => 'Billing Postcode',
                    'billing_phone'         => 'Billing Phone',
                    'shipping_address_1'    => 'Shipping Address 1',
                    'shipping_city'         => 'Shipping City',
                    'shipping_postcode'     => 'Shipping Postcode',
                    'shipping_state'        => 'Shipping State',
                    'description'           => 'Biographical Info',
                    'display_name'          => 'Display name publicly as',
                  );
 * $wc_data variable return wc data.
 */
if ( ! function_exists( 'wc_facturozor_customer_synch' ) ) {
  function wc_facturozor_customer_synch( $facturozor, $user_id, $wc_data ) {
      
    $wc_facturozor_module = ( isset( $wc_data['wc_facturozor_module'] ) ? $wc_data['wc_facturozor_module'] : '' );
    $wc_facturozor_fields = ( isset( $wc_data['wc_facturozor_fields'] ) ? $wc_data['wc_facturozor_fields'] : array() );
    $user_info = get_userdata( $user_id );
    //$customer_array = new WC_Customer( $user_id );
    //$customer = $customer_array->get_data();
    $data = array();
  
    if ( $wc_facturozor_fields != null ) {
      foreach ( $wc_facturozor_fields as $key => $value ) { //key = billing_company and $value['key'] = name_of_enterprise
        if ( $value['key'] ) {
          if ( isset( $user_info->{$key} ) ) {
            if ( is_array( $user_info->{$key} ) ) {
              $user_info->{$key} = implode(';', $user_info->{$key} );
            }
            $data[$value['key']] = strip_tags( $user_info->{$key} );
          }else{
            $meta_value = get_user_meta($user_id, $key, true);
            if(isset($meta_value)){
              $data[$value['key']] = strip_tags($meta_value);
            }
            /*$billing_array = $customer['billing'];
            if($key == 'billing_company' && isset($billing_array) && isset($billing_array['billing_company']) ){
              $data[$value['key']] = 
            }
            if(isset($customer['billing']) && count($customer['billing']) > 0) {
              
              $data['billing_company'] = isset($billing_array) && isset($billing_array['']) ? $billing_array[''] : "";
              $data['billing_address_1'] = isset($billing_array) && isset($billing_array['address_1']) ? $billing_array['address_1'] : "";
              $data['billing_city'] = isset($billing_array) && isset($billing_array['city']) ? $billing_array['city'] : "";
              $data['zip'] = isset($billing_array) && isset($billing_array['postcode']) ? $billing_array['postcode'] : "";
              $data['billing_'] = isset($billing_array) && isset($billing_array['']) ? $billing_array[''] : "";
              $data['billing_'] = isset($billing_array) && isset($billing_array['']) ? $billing_array[''] : "";
              $data['billing_'] = isset($billing_array) && isset($billing_array['']) ? $billing_array[''] : "";
            }*/
          }
        }
      }
      $wc_facturozor_id = get_user_meta( $user_id, 'wc_facturozor_id', true );
                 
      if ( $data != null ) {
        $data['item_id'] = $user_id;
        $item_id = ( isset( $wc_facturozor_id ) && $wc_facturozor_id != 0 ? intval($wc_facturozor_id) : 0 );
        if ( isset($item_id) && $item_id != 0 ) {
          $response = $facturozor->updateRecord( $wc_facturozor_module, $data, $item_id );                  
        } else {
          $response = $facturozor->addRecord($wc_facturozor_module, $data );
        }
        //if(isset($response) && isset($response['status']) && $response['status'] == 'success'){
        if(isset($response) && isset($response->status) && $response->status == 'success'){  
          $item_id = $response->id; // $response['id'];
          $wc_facturozor_id = intval($item_id);
          update_user_meta( $user_id, 'wc_facturozor_id', $wc_facturozor_id );
          update_user_meta( $user_id, 'wc_facturozor_last_sync_success', date( 'Y-m-d H:i:s' ) );
        }else{
          update_user_meta( $user_id, 'wc_facturozor_last_sync_failed', date( 'Y-m-d H:i:s' ) );
        }
      }            
      
    }  
  }
}

/*
 * Order synch.
 * $order_id variable return order id.
 * $wc_data variable return wc data.
 *
 * $tax = new WC_Tax();
 * $base_tax_rates = $tax->get_shop_base_rate($product->tax_class);
 * $tax_rates = $tax->get_rates($product->get_tax_class());
 * $taxes = $tax->calc_tax($price, $base_tax_rates, false);
 */
if ( ! function_exists( 'wc_facturozor_order_synch' ) ) {
  function wc_facturozor_order_synch( $facturozor, $order_id, $wc_data ) {
    $wc_facturozor_module = ( isset( $wc_data['wc_facturozor_module'] ) ? $wc_data['wc_facturozor_module'] : '' );
    $wc_facturozor_fields = ( isset( $wc_data['wc_facturozor_fields'] ) ? $wc_data['wc_facturozor_fields'] : array() );
    $order_info = get_post( $order_id );
    $order_obj = wc_get_order( $order_id );
    $order = $order_obj->get_data();
    $wc_facturozor_id = get_post_meta( $order_id, 'wc_facturozor_id', true );
    $item_id = ( isset( $wc_facturozor_id ) && $wc_facturozor_id != 0 ? intval($wc_facturozor_id) : 0 );
    $data = array();
    if ( $wc_facturozor_fields != null && $item_id == 0 ) {
      foreach ( $wc_facturozor_fields as $field_key => $field_value ) {
        if ( $field_value['key'] ) {
          if ( $field_key == 'post_date' || $field_key == 'post_excerpt' || $field_key == 'post_status' ) {
            $value = $order_info->{$field_key};
            if ( $field_key == 'post_date' ) {
              $value = date( 'Y-m-d', strtotime( $value ) );
            }
          } else if ( $field_key == 'order_number' ) {
            $value = '#'.$order_id;
          } else if ( $field_key == 'order_products' ) {
            $items = $order_obj->get_items();
            $item_array = array();
            //$value = array();
            if ( $items != null ) {
              foreach ( $items as $item ) {
                $item_data = $item->get_data();
                if(isset($item_data) && isset($item_data['product_id']) && intval($item_data['product_id']) > 0 ){
                  $wc_facturozor_id_product = get_post_meta( $item_data['product_id'], 'wc_facturozor_id', true );
                  if(isset($wc_facturozor_id_product) && intval($wc_facturozor_id_product) > 0 ){
                    $item_data['wc_facturozor_id'] = intval($wc_facturozor_id_product);
                  }else{
                    //include product if wc_facturozor_id_product is not there
                    $product = wc_get_product( $item_data['product_id']  );
                    $product_data =  $product->get_data();
                    $product_data['tax_class'] = $product->get_tax_class();
                    $product_data['cat_ids'] = $product->get_category_ids();
                    $cats = array();
                    if(isset($product_data['cat_ids']) && !empty($product_data['cat_ids']) && is_array($product_data['cat_ids']) ){
                      foreach ($product_data['cat_ids'] as $c) {
                        $cid = $c;
                        if( $term = get_term_by( 'id', $cid, 'product_cat' ) ){
                          $cats[] = $term->name;
                        }
                      }
                    }
                    $product_data['cats'] = $cats;
                    
                    if(isset($product_data['tax_class']) && !empty($product_data['tax_class'])){
                      $tax_rates = WC_Tax::get_rates( $product_data['tax_class'] );
                      if (!empty($tax_rates)) {
                        $tax_rate = reset($tax_rates);
                        $product_data['tax_rate'] = $tax_rate;
                      }
                      //$tax_rates = WC_Tax::get_rates_for_tax_class( $product_data['tax_class'] );        
                    }else{
                      $product_data['tax_rates'] = array();
                    }
                    $item_data['product'] = $product_data;
                    $item_data['wc_facturozor_id'] = 0;
                  }
                }
                $item_array []  = $item_data;
                //$value[] = $item_data['name'].' x '.$item_data['quantity'];
              }
            }
            //$value = implode( "\n\n", $value );
            $value = json_encode($item_array);
          } else {
            $value = get_post_meta( $order_id, $field_key, true );
          }
          if ( is_array( $value ) ) {
            $value = implode(';', $value );
          }
          $order[$field_value['key']] = strip_tags( $value );
        }
        //add customer info
        if(isset($order) && isset($order['customer_id']) && intval($order['customer_id']) > 0 ){
          $wc_facturozor_id_customer = get_user_meta( $order['customer_id'], 'wc_facturozor_id', true );
          if(isset($wc_facturozor_id_customer) && intval($wc_facturozor_id_customer) > 0 ){
            $order['wc_facturozor_id_customer'] = intval($wc_facturozor_id_customer);
          }else{
            $order['wc_facturozor_id_customer'] = 0;
          }
        }else{
          $order['wc_facturozor_id_customer'] = 0;
        }        
      }
      if ( $order != null ) {
        $order['item_id'] = $order_id;
        if ( isset($item_id) && $item_id != 0 ) {
          $response = $facturozor->updateRecord( $wc_facturozor_module, $order, $item_id );                  
        } else {
          $response = $facturozor->addRecord($wc_facturozor_module, $order );
        }
        if(isset($response) && isset($response->status) && $response->status == 'success'){  
          $item_id_response = $response->id; // $response['id'];
          $wc_facturozor_id = intval($item_id_response);
          update_post_meta( $order_id, 'wc_facturozor_id', $wc_facturozor_id );
          update_post_meta( $order_id, 'wc_facturozor_last_sync_success', date( 'Y-m-d H:i:s' ) );
          delete_post_meta( $order_id, 'wc_facturozor_last_sync_failed');
        }else{
          update_post_meta( $order_id, 'wc_facturozor_last_sync_failed', date( 'Y-m-d H:i:s' ) );
        }
      } 

    }
  }
}
if ( ! function_exists( 'wc_facturozor_product_synch' ) ) {
  function wc_facturozor_product_synch( $facturozor, $product_id, $wc_data ) {
    $wc_facturozor_module = ( isset( $wc_data['wc_facturozor_module'] ) ? $wc_data['wc_facturozor_module'] : '' );
    $wc_facturozor_fields = ( isset( $wc_data['wc_facturozor_fields'] ) ? $wc_data['wc_facturozor_fields'] : array() );
    $product_info = get_post( $product_id );
    $product = wc_get_product( $product_id  );
    $data = array();
    if ( $wc_facturozor_fields != null ) {
      foreach ( $wc_facturozor_fields as $field_key => $field_value ) {
        if ( $field_value['key'] ) {
          if ( $field_key == '_purchase_note' || $field_key == 'name' || $field_key == 'post_date' || $field_key == 'post_excerpt' || $field_key == 'post_status' ) {
            $value = $product_info->{$field_key};
            if ( $field_key == 'post_date' ) {
              $value = date( 'Y-m-d', strtotime( $value ) );
            }elseif ( $field_key == 'name' ) {
              $value = $product_info->post_title;
            }
            elseif ( $field_key == '_purchase_note' ) {
              $value = $product_info->post_content;
            }          
          } else {
            $value = get_post_meta( $product_id, $field_key, true );
          }
          if ( is_array( $value ) ) {
            $value = implode(';', $value );
          }

          $data[$field_value['key']] = strip_tags( $value );
        }
      }
                

      
      $product_data = $product->get_data();
      $product_data['attributes'] = $product->get_attributes();
      $product_data['meta_data'] = $product->get_meta_data();
      $product_data['tax_class'] = $product->get_tax_class();
      $product_data['cat_ids'] = $product->get_category_ids();
      $cats = array();
      if(isset($product_data['cat_ids']) && !empty($product_data['cat_ids']) && is_array($product_data['cat_ids']) ){
        foreach ($product_data['cat_ids'] as $c) {
          $cid = $c;
          if( $term = get_term_by( 'id', $cid, 'product_cat' ) ){
            $cats[] = $term->name;
          }
        }
      }
      $product_data['cats'] = $cats;
      
      if(isset($product_data['tax_class']) && !empty($product_data['tax_class'])){
        $tax_rates = WC_Tax::get_rates( $product_data['tax_class'] );
        if (!empty($tax_rates)) {
          $tax_rate = reset($tax_rates);
          $product_data['tax_rate'] = $tax_rate;
        }
        //$tax_rates = WC_Tax::get_rates_for_tax_class( $product_data['tax_class'] );        
      }else{
        $product_data['tax_rates'] = array();
      }

      $product_data['image_url'] = wp_get_attachment_url( $product->get_image_id() );
      $data['product'] = $product_data;
      //WC_Tax::get_rates_for_tax_class( $tax_class )

      $wc_facturozor_id = get_post_meta( $product_id, 'wc_facturozor_id', true );
      if ( $data != null ) {
        $item_id = ( isset( $wc_facturozor_id ) && $wc_facturozor_id != 0 ? intval($wc_facturozor_id) : 0 );
        $data['item_id'] = $product_id;
        if ( isset($item_id) && $item_id != 0 ) {
          $response = $facturozor->updateRecord( $wc_facturozor_module, $data, $item_id );                  
        } else {
          $response = $facturozor->addRecord($wc_facturozor_module, $data );
        }
        if(isset($response) && isset($response->status) && $response->status == 'success'){  
        //if(isset($response) && isset($response['status']) && $response['status'] == 'success'){
          $item_id = $response->id; // $response['id'];
          $wc_facturozor_id = intval($item_id);
          update_post_meta( $product_id, 'wc_facturozor_id', $wc_facturozor_id );
          update_post_meta( $product_id, 'wc_facturozor_last_sync_success', date( 'Y-m-d H:i:s' ) );
        }else{
          update_post_meta( $product_id, 'wc_facturozor_last_sync_failed', date( 'Y-m-d H:i:s' ) );
        }
      } 
    }
  }
}
if ( ! function_exists( 'wc_facturozor_customers_synch_all' ) ) {
    function wc_facturozor_customers_synch_all(){

    }
}
if ( ! function_exists( 'wc_facturozor_customers_synch_all' ) ) {
    function wc_facturozor_products_synch_all(){
        
    }
}
if ( ! function_exists( 'wc_facturozor_customers_synch_all' ) ) {
    function wc_facturozor_orders_synch_all(){
        
    }
}

if ( ! function_exists( 'wc_facturozor_payment_synch' ) ) {
  function wc_facturozor_payment_synch($facturozor,$order_id){
    //mark payment as paid and order as paid.
    $wc_facturozor_id = get_post_meta( $order_id, 'wc_facturozor_id', true );
    $order_obj = wc_get_order( $order_id );
    $order = $order_obj->get_data();
    $order['wc_facturozor_id'] = (isset($wc_facturozor_id) && $wc_facturozor_id != '' && intval($wc_facturozor_id)> 0) ? intval($wc_facturozor_id) : 0;
    $response = $facturozor->updatePayment($order);    
  }
}


